

function PopWorkflowTools_Execute(  )
{
	// first gather some info about selection
	var nSel = Selection.Count;		
	var bSelIs1Clone = false;
	var bCloneOfTheSelObjExists = false;
	var bSelIs13DObject = false;
	var bSelIs1SubC = false;
	if(nSel == 1) {		
		var the1Sel = Selection.Item(0);
		var the1SelO = the1Sel;
		try {
			var selPrim = the1Sel.ActivePrimitive;
			if(selPrim)
				bSelIs13DObject = true;
			else {
				selPrim = the1Sel.SubComponent.Parent3DObject.ActivePrimitive; // throws if not subc
				bSelIs1SubC = true;			
				the1SelO = selPrim.Parent;	
			}
			scene_copyops = Application.ActiveSceneRoot.FindObjectsFromCLSID("{449E967D-EAF1-11D3-934F-009027BC3E26}");
			n = scene_copyops.Count;
			for(i=0; i<n; i++) {
				copyop = scene_copyops.Item(i);
				if(copyop.Parent.FullName == selPrim.FullName) {
					bSelIs1Clone = true;
					the1Master = copyop.InputPorts(0).Target2;
				}
				if(copyop.InputPorts(0).Target2.FullName == selPrim.FullName) 
					bCloneOfTheSelObjExists = true;
			}		
		} catch(e) {
		} 
	}
	
	var popup = XPOP();
	popup.font = "Segoe UI";
	popup.fontsize = 13;
	popup.origin_x = 12;
	popup.origin_y = 62;

	last = GetGlobal('PopWorkflowTools_lastCmd');
	
	popup.AddHeader( "Workflow Tools", 0x50e4ac);	
	
	if(nSel == 1) { 		
		if( bSelIs1SubC && the1Sel.SubComponent.ComponentCollection.Count > 7) {
			str = the1Sel.SubComponent.ComponentCollection.Count + " ";4
			switch( the1Sel.SubComponent.type  ) {
				case "polySubComponent": str += "polygons of " + the1Sel.Name; break;
				case "edgeSubComponent": str += "edges of " + the1Sel.Name; break;
				case "pntSubComponent": str += "points of " + the1Sel.Name; break;
			}
		}
		else
			str = the1Sel.FullName;	
		if (str.length > 42)
			str = str.substr(0,42) + "..";
		item = popup.AddItem( str, "");	
	}
	else 
		item = popup.AddItem( nSel + " Objects selected", 0x50e4ac);
		
	item.EnableItem(0); 		
	item.padding_top = 8;
	item.padding_bottom = 6;
	
	if(bSelIs13DObject && !(bSelIs1Clone || bCloneOfTheSelObjExists)) {
		item = popup.AddItem( "&Create mirrored clone", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 1); PopWorkflowTools_runCmd(1);"); 	 
		if(last==1) item.SetIcon("Loop");
		bFoundClone = true;
	}
	if(bSelIs1Clone) {
		item = popup.AddItem( "<Clone>: &Swap w/Master", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 2); PopWorkflowTools_runCmd(2);"); 	 
		if(last==2) item.SetIcon("Loop");
		item = popup.AddItem( "<Clone>: &Replace old Master", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 3); PopWorkflowTools_runCmd(3);"); 	 
		if(last==3) item.SetIcon("Loop");
	}
	if(bCloneOfTheSelObjExists) {
		item = popup.AddItem( "<Master>: &Swap w/Clone", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 4); PopWorkflowTools_runCmd(4);"); 	 
		if(last==4) item.SetIcon("Loop");
		bFoundClone = true;
	}
	if(nSel>0) {
		item = popup.AddItem( "&Toggle Selectability", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 5); PopWorkflowTools_runCmd(5);");
		if(last==5) item.SetIcon("Loop");	
	}
	
	ias = GetValue("preferences.TransformProperties.translate");
	ias_s = GetValue("preferences.TransformProperties.translateslow");
	ias_m = GetValue("preferences.TransformProperties.translatemed");
	ias_f = GetValue("preferences.TransformProperties.translatefast");

	if(ias == ias_s)
		item = popup.AddHeader("Interaction Speed", 0xe88aa0);
	else if(ias == ias_m)
		item = popup.AddHeader("Interaction Speed", 0x8ae8a0);
	else if(ias == ias_f)
		item = popup.AddHeader("Interaction Speed", 0xfece20);
	else 
		item = popup.AddHeader("Interaction Speed", 0xaaaaaa );
	item.spacing_top = 8;
	
	item = popup.AddItem( "Slo&w", "PopWorkflowTools_runCmd(15);");
	if(ias == ias_s) item.SetIcon("Checkmark");
	
	item = popup.AddItem( "&Medium", "PopWorkflowTools_runCmd(16);");
	if(ias == ias_m) item.SetIcon("Checkmark");
		
	item = popup.AddItem( "&Fast", "PopWorkflowTools_runCmd(17);");
	if(ias == ias_f) item.SetIcon("Checkmark");
	
	popup.AddSeparator();
	
	
	item = popup.AddItem( "Camera Clipping &Low settings", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 30); PopWorkflowTools_runCmd(30);");
	if(last==30) item.SetIcon("Loop");
	item = popup.AddItem( "Camera Clipping &Medium settings", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 31); PopWorkflowTools_runCmd(31);");
	if(last==31) item.SetIcon("Loop");
	item = popup.AddItem( "Camera Clipping Ma&ximum settings (Default)", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 31); PopWorkflowTools_runCmd(32);");
	if(last==32) item.SetIcon("Loop");
	
	
	popup.AddSeparator();
		

	item = popup.AddItem( "Reset Dup. Tr&ansform Options", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 14); PopWorkflowTools_runCmd(14);");
	if(last==14) item.SetIcon("Loop");

	
	if(bSelIs13DObject)  {
		item = popup.AddItem( "Toggle ICE Color Display", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 18); PopWorkflowTools_runCmd(18);");
		if(last==18) item.SetIcon("Loop");
	}
	
	if(nSel == 1 && Selection.Item(0).type == "camera") {
		item = popup.AddItem( "Create Camera Interest", "SetGlobalIfCtrlDown('PopWorkflowTools_lastCmd', 19); PopWorkflowTools_runCmd(19);");		
		if(last==19) item.SetIcon("Loop");
	} 
	
	popup.AddSeparator();
	
	item = popup.AddItem ("Edit this popup", "EditThisFile(1);");	
	item.SetIcon("Write2");
	
	eval( popup.Track() );
	
	return true;		
}

function PopWorkflowTools_runCmd(iCmd)
{	
	// first gather some info about selection
	var nSel = Selection.Count;		
	var bSelIs1Clone = false;
	var bCloneOfTheSelObjExists = false;
	var bSelIs13DObject = false;
	var bSelIs1SubC = false;
	if(nSel == 1) {		
		var the1Sel = Selection.Item(0);
		var the1SelO = the1Sel;
		try {
			var selPrim = the1Sel.ActivePrimitive;
			if(selPrim)
				bSelIs13DObject = true;
			else {
				selPrim = the1Sel.SubComponent.Parent3DObject.ActivePrimitive; // throws if not subc
				bSelIs1SubC = true;
				the1SelO = selPrim.Parent;
			}
			scene_copyops = Application.ActiveSceneRoot.FindObjectsFromCLSID("{449E967D-EAF1-11D3-934F-009027BC3E26}");
			n = scene_copyops.Count; 
			for(i=0; i<n; i++) {
				copyop = scene_copyops.Item(i);
				if(copyop.Parent.FullName == selPrim.FullName) {
					bSelIs1Clone = true;
					the1Master = copyop.InputPorts(0).Target2.Parent;
				}
				if(copyop.InputPorts(0).Target2.FullName == selPrim.FullName) 
					bCloneOfTheSelObjExists = true;
			}		
		} catch(e) {
		} 
	}
	
	switch(iCmd)
	{
		case 1:
			ixCloned = the1SelO.Name.lastIndexOf("_cloned");
			if(ixCloned>0) {
				the1SelO.Name = the1SelO.Name.substr(0, ixCloned);
				ResetTransform(the1SelO, siCtr, siSRT, siXYZ);
			}
			var clones = Clone(the1SelO);
			var clone = clones.Item(0);
			Scale( clone, -1, 1, 1 );	
			clone.Name = the1SelO.Name + "_cloned";
			SelectObj(the1SelO);
			break;
		case 2:
			logmessage(the1Master);
			Scale(the1Master, -1, 1, 1, siAbsolute, siPivotCOG, siObj, siX, null, null, null, null, null, null, null, 0, null);
			ResetTransform(the1Master, siCtr, siSRT, siXYZ);	
			SelectObj(the1Master);
			break;
		case 3:	
			ixCloned = the1SelO.Name.lastIndexOf("_cloned");			
			if(ixCloned>0) {
				FreezeModeling(the1SelO);
				new_name = the1SelO.Name.substr(0, ixCloned);
				try { DeleteObj(the1Master); } catch(e) {}
				the1SelO.Name = new_name;
				ResetTransform(the1SelO, siCtr, siSRT, siXYZ);
			}
			var clones = Clone(the1SelO);
			var clone = clones.Item(0);
			Scale( clone, -1, 1, 1 );
			clone.Name = the1SelO.Name + "_cloned";
			SelectObj(the1SelO);
			break;
		case 4:		
			Scale(the1SelO, -1, 1, 1, siAbsolute, siPivotCOG, siObj, siX, null, null, null, null, null, null, null, 0, null);
			ResetTransform(the1SelO, siCtr, siSRT, siXYZ);			
			break;
		case 5:
			ToggleSelectability(null, null);
			DeselectAll();
			break;
		case 14:	
			SetValue("preferences.duplicate.tx", 0, null);
			SetValue("preferences.duplicate.ty", 0, null);
			SetValue("preferences.duplicate.tz", 0, null);
			SetValue("preferences.duplicate.rx", 0, null);
			SetValue("preferences.duplicate.ry", 0, null);
			SetValue("preferences.duplicate.rz", 0, null);
			SetValue("preferences.duplicate.sz", 1, null);
			SetValue("preferences.duplicate.sy", 1, null);
			SetValue("preferences.duplicate.sx", 1, null);
			break;
		case 15:
			SetValue("preferences.TransformProperties.translate", 
				GetValue("preferences.TransformProperties.translateslow"), null);
			SetValue("preferences.TransformProperties.rotate", 
				GetValue("preferences.TransformProperties.rotateslow"), null);
			SetValue("preferences.TransformProperties.scale", 
				GetValue("preferences.TransformProperties.scaleslow"), null);			
			break;
		case 16:
			SetValue("preferences.TransformProperties.translate", 
				GetValue("preferences.TransformProperties.translatemed"), null);
			SetValue("preferences.TransformProperties.rotate", 
				GetValue("preferences.TransformProperties.rotatemed"), null);
			SetValue("preferences.TransformProperties.scale", 
				GetValue("preferences.TransformProperties.scalemed"), null);			
			break;
		case 17:
			SetValue("preferences.TransformProperties.translate", 
				GetValue("preferences.TransformProperties.translatefast"), null);
			SetValue("preferences.TransformProperties.rotate", 
				GetValue("preferences.TransformProperties.rotatefast"), null);
			SetValue("preferences.TransformProperties.scale", 
				GetValue("preferences.TransformProperties.scalefast"), null);			
			break;
		case 18:
			cav = the1SelO.Material.CAV.Value;
			if(cav == "None")
				SetInstanceDataValue(the1SelO, "Soues.Materials.DefaultLib.Material.CAV", "Color");
			else
				SetInstanceDataValue(the1SelO, "Soues.Materials.DefaultLib.Material.CAV", "None");
			break;
		case 19:
			CreateCameraInterest();
			break;
			
		
		case 30: SetValue(GetViewCamera(-1)+".camera.near", 0.1, null);
				SetValue(GetViewCamera(-1)+".camera.far", 128, null);
				break;
		case 31: SetValue(GetViewCamera(-1)+".camera.near", 0.1, null);
				SetValue(GetViewCamera(-1)+".camera.far", 1000, null);
				break;
		case 32: SetValue(GetViewCamera(-1)+".camera.near", 0.1, null);
				SetValue(GetViewCamera(-1)+".camera.far", 32768, null);
				break;

			
			
	}	
}

function PopWorkflowToolsRepeatLast_Execute(  )
{
	last = GetGlobal( "PopWorkflowTools_lastCmd" );
	PopWorkflowTools_runCmd( last?last:1 );
	return true;
}

function PopSmooth_runCmd( iCmd )
{               
	var oOp;
	switch(iCmd)
	{
	case 1: ApplyOp("Relax", null, 3, siPersistentOperation, null, 0);
			InspectObj(oOp);
			break;
	case 2: oOp = ApplyOp("Smooth", null, 3, siPersistentOperation, null, 0);
			for( i=0; i<oOp.Count; i++)
				SetValue( oOp.item(i) + ".strength", 15, null);
			InspectObj(oOp);
			break;
	case 3: oOp = ApplyOp("Smooth", null, 3, siPersistentOperation, null, 0);
			for( i=0; i<oOp.Count; i++) {
				SetValue( oOp.item(i) + ".strength", 15, null);
				SetValue( oOp.item(i) + ".falloffradius", 200, null);
				SetValue( oOp.item(i) + ".falloffsharpness", 2, null);
			}
			InspectObj(oOp);
			break;
	case 4: oOp = ApplyOp("Smooth", null, 3, siPersistentOperation, null, 0);
			InspectObj(oOp);
			break;
	case 5: oOp = ApplyOp("Smooth", null, 3, siPersistentOperation, null, 0);
			for( i=0; i<oOp.Count; i++)
				SetValue( oOp.item(i) + ".strength", 0, null);
			DeselectAll();
			InspectObj(oOp);
			break;
	case 6: oOp = ApplyOp("Smooth", null, 3, siPersistentOperation, null, 0);
			for( i=0; i<oOp.Count; i++)
				SetValue( oOp.item(i) + ".extrapolation", -2, null);
			DeselectAll();
			InspectObj(oOp);
			break;
	}
}

function PopSmooth_ToggleTopoEditSmooth()
{
	oOp = GetGlobal("PopSmooth_topoSmoothOp");
	if(oOp) 
	{
		DeleteObj( oOp );	
		SetGlobal("PopSmooth_topoSmoothOp", false);
		return;
	}
	
	oOp = ApplyOp("Smooth", null, 3, siPersistentOperation, null, 0);
	SetGlobal("PopSmooth_topoSmoothOp", oOp);
	SetValue( oOp.item(0) + ".strength", 120, null);
}


function PopSmooth_Execute(  )
{
	var popup = XPOP();
	
	popup.AddHeader( "Smooth Tools", 0xa0e060); // ( parent node, title, color in hex )
	popup.font = "Segoe UI";
	popup.fontsize = 13;
	popup.origin_x = 36;
	popup.origin_y = 36;

	last = GetGlobal('PopSmooth_lastCmd');
		 	 	 
	item = popup.AddItem( "Apply &Relax", "SetGlobalIfCtrlDown('PopSmooth_lastCmd', 1); PopSmooth_runCmd(1);");
	if(last==1) item.SetIcon("Loop");

	item = popup.AddItem( "Apply stron&g Smooth", "SetGlobalIfCtrlDown('PopSmooth_lastCmd', 2); PopSmooth_runCmd(2);");
	if(last==2) item.SetIcon("Loop");
	
	item = popup.AddItem( "Apply stron&g Smooth w. f/o", "SetGlobalIfCtrlDown('PopSmooth_lastCmd', 3); PopSmooth_runCmd(3);");
	if(last==3) item.SetIcon("Loop");
	
	popup.AddSeparator();

	item = popup.AddItem( "&Smooth", "SetGlobalIfCtrlDown('PopSmooth_lastCmd', 4); PopSmooth_runCmd(4);");
	if(last==4) item.SetIcon("Loop");
	item = popup.AddItem( "Smooth 0 and &deselect", "SetGlobalIfCtrlDown('PopSmooth_lastCmd', 5); PopSmooth_runCmd(5);");
	if(last==5) item.SetIcon("Loop");
	item = popup.AddItem( "Sharpen", "SetGlobalIfCtrlDown('PopSmooth_lastCmd', 6); PopSmooth_runCmd(6);");
	if(last==6) item.SetIcon("Loop");
	
	popup.AddSeparator();

	item = popup.AddItem( "Topo Edit Smooth", "PopSmooth_ToggleTopoEditSmooth();");
	if(GetGlobal("PopSmooth_topoSmoothOp")) item.SetIcon("Checkmark");
	
	popup.AddSeparator();

	item = popup.AddItem ("Edit this popup", "EditThisFile(64);");	
	item.SetIcon("Write2");	
	
	eval( popup.Track() );
	
	return true;
}

function PopSmoothRepeatLast_Execute(  )
{
	last = GetGlobal( "PopSmooth_lastCmd" );
	PopSmooth_runCmd( last?last:1 );
	return true;
}
	
function PopHide_runCmd( iCmd )
{
	switch(iCmd)
	{
	case 1: ToggleVisibility();
			break;
	case 2: ToggleAllVisibility();
			break;
	case 3: ToggleRenderRegionVisibility();
			break;
	case 4: HideUnselected(null, null);
			break;
	case 5:	ToggleVisibility(null, null, null);
			break;
	case 6:	UnhideAllPolygons();
			break;	
			
	}
}

// PopHide
function PopHide_Execute(  )
{
	var popup = XPOP();
	
	popup.AddHeader( "Hide Tools", 0x808080); // ( parent node, title, color in hex )
	popup.font = "Segoe UI";
	popup.fontsize = 13;
	popup.origin_x = 36;
	popup.origin_y = 36;
	 	 
	last = GetGlobal('PopHide_lastCmd');
		 
	item = popup.AddItem( "&Toggle Selection", "SetGlobalIfCtrlDown('PopHide_lastCmd', 1); PopHide_runCmd(1);");
	if(last==1) item.SetIcon("Loop");
	item = popup.AddItem( "Toggle &All (Vis-Options)", "SetGlobalIfCtrlDown('PopHide_lastCmd', 2); PopHide_runCmd(2);");
	if(last==2) item.SetIcon("Loop");
	item = popup.AddItem( "Toggle Render Region", "SetGlobalIfCtrlDown('PopHide_lastCmd', 3); PopHide_runCmd(3);");
	if(last==3) item.SetIcon("Loop");
	
	popup.AddSeparator();

	item = popup.AddItem( "&Isolate Polygon Selection", "SetGlobalIfCtrlDown('PopHide_lastCmd', 4); PopHide_runCmd(4);");
	if(last==4) item.SetIcon("Loop");	
	item = popup.AddItem( "Hide &Polygon Selection", "SetGlobalIfCtrlDown('PopHide_lastCmd', 5); PopHide_runCmd(5);");
	if(last==5) item.SetIcon("Loop");
	item = popup.AddItem( "&Unhide all Polygons", "SetGlobalIfCtrlDown('PopHide_lastCmd', 6); PopHide_runCmd(6);");
	if(last==6) item.SetIcon("Loop");

	popup.AddSeparator();

	item = popup.AddItem ("Edit this popup", "EditThisFile(411);");	
	item.SetIcon("Write2");
	
	eval( popup.Track() );
	
	return true;	
}

function PopHideRepeatLast_Execute(  )
{
	last = GetGlobal( "PopHide_lastCmd" );
	PopHide_runCmd( last?last:1 );
	return true;
}

function PopViews_Execute(  ) // ALT+V
{
	popup = XPOP();
	popup.font = "Segoe UI";
	popup.fontsize = 13;
	popup.origin_x = 36;
	popup.origin_y = 36;
	
	last = GetGlobal('PopViews_lastCmd');
	
	popup.AddHeader("View shortcuts", 0xCCEE22);
	
	item=popup.AddItem("&I - ICE Tree", "OpenView('Ice Tree')" );
	item.SetIcon("Sitemap");
	if(last=="OpenView('Ice Tree')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&R - Render Tree", "OpenView('Render Tree')" );
	item.SetIcon("Sitemap");
	if(last=="OpenView('Render Tree')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&A - Animation Editor", "OpenView('Animation Editor')" );
	if(last=="OpenView('Animation Editor')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&Y - Animation Mixer", "OpenView('Animation Mixer')" );
	if(last=="OpenView('Animation Mixer')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&B - Brush Properties", "InspectObj('BrushProperties')" );
	if(last=="OpenView('BrushProperties')") item.SetIcon("Loop");	
	 
	item=popup.AddItem("&O - Object View", "OpenView('Object View')" );
	if(last=="OpenView('Object View')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&H - Shape Manager", "OpenView('Shape Manager')" );
	if(last=="OpenView('Shape Manager')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&T - Texture Editor", "OpenView('Texture Editor')" );
	item.SetIcon("Picture");
	if(last=="OpenView('Texture Editor')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&M - Material Manager", "OpenView('Material Manager')" );
	if(last=="OpenView('Material Manager')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&E - Render Manager", "OpenView('Render Manager')" );
	if(last=="OpenView('Render Manager')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&K - SDK Explorer", "OpenView('SDK Explorer')" );
	item.SetIcon("Tool");
	if(last=="OpenView('SDK Explorer')") item.SetIcon("Loop");	
	
	item=popup.AddItem("&S - Script Editor", "OpenView('Script Editor')" );
	item.SetIcon( "Write2" );
	if(last=="OpenView('Script Editor')") item.SetIcon("Loop");	

	popup.AddSeparator();

	item = popup.AddItem ("Edit this popup", "EditThisFile(160);");	
	item.SetIcon("Write2");

	str = popup.Track();
	if(str!="") {
		SetGlobal("PopViews_lastCmd", str);
		eval(str);
	}
	
	return true;
}

function PopViewsRepeatLast_Execute(  ) // CTRL+ALT+V . repeat last
{
	last = GetGlobal( "PopViews_lastCmd" )
	eval( last );
	return true;
}

function std_init(c)
{
	var oCmd;
	oCmd = c.Soue;
	oCmd.Description = "";
	oCmd.SetFlag(siNoLogging,true);
	oCmd.ReturnValue = true;

	return true;
}

function EditThisFile(line)
{
	path = Application.Plugins("MiscPopupsPlugin").Filename;
//path = path.slice(0, path.indexOf("MiscPopups"));		
//	logmessage(path);
	//filename = XSIUtils.BuildPath( path, "MiscPopups/Application/Plugins/MiscPopups.js" )
//	logmessage(filename);
	ShowFileForEdit(path, line);
}

function SetGlobalIfCtrlDown(vname, val)
{
	if(GetKeyboardState()(1) & 0x02)
		SetGlobal(vname, val);
}

function PopSmooth_Init( c ) { SetGlobal("PopSmooth_lastCmd", 1); std_init(c); 
	// preload some icons...
	tmp = XPOP();
	item = tmp.AddItem( "IconLoad", "IconLoad" );
	item.SetIcon("Checkmark");
	item.SetIcon("Loop");
	item.SetIcon("Write2");
	item.SetIcon("Sitemap");
	item.SetIcon("Picture");
}

function PopHide_Init( c ) { SetGlobal("PopHide_lastCmd", 1); std_init(c); }
function PopViews_Init( c ) { SetGlobal("PopViews_lastCmd", 1); std_init(c); }
function PopWorkflowTools_Init( c ) { SetGlobal("PopWorkflowTools_lastCmd", 1); std_init(c); }

function PopSmoothRepeatLast_Init( c ) { std_init(c); }
function PopHideRepeatLast_Init( c ) { std_init(c); }
function PopViewsRepeatLast_Init( c ) { std_init(c); }
function PopWorkflowToolsRepeatLast_Init( c ) { std_init(c); }

function XSILoadPlugin( in_reg )
{
	in_reg.Author = "";
	in_reg.Name = "MiscPopupsPlugin";
	in_reg.Email = "";
	in_reg.URL = "";
	in_reg.Major = 1;
	in_reg.Minor = 0;

	in_reg.RegisterCommand("PopSmooth","PopSmooth");
	in_reg.RegisterCommand("PopSmoothRepeatLast","PopSmoothRepeatLast");
	
	in_reg.RegisterCommand("PopHide","PopHide");
	in_reg.RegisterCommand("PopHideRepeatLast","PopHideRepeatLast");
		 
	in_reg.RegisterCommand("PopViews","PopViews");
	in_reg.RegisterCommand("PopViewsRepeatLast","PopViewsRepeatLast");
	
	in_reg.RegisterCommand("PopWorkflowTools","PopWorkflowTools");
	in_reg.RegisterCommand("PopWorkflowToolsRepeatLast","PopWorkflowToolsRepeatLast");

	return true;
}